#!/usr/bin/python3
version = "0.2.0"

# Imports, of course.
import os
import socket
import subprocess
import shutil
from datetime import datetime
from os.path import expanduser

# Some initial variables
user = os.getlogin()
initDirectory = expanduser("~") 
argList = ["", ""]

# Start work on checking whether a config file exists
if os.path.isfile(expanduser("~") + "/.config/mash/mash.conf") == False:
    configFilePath = "/etc/mash/mash.conf"
else:
    configFilePath = (expanduser("~") + "/.config/mash/mash.conf")
# Parse config file, adding variables
configFileFile = open(configFilePath)
configFile = configFileFile.read()

confArgNumber = 0
confArgList = ["", ""]

for line in configFile:
    for letter in line:
        if letter == ':':
            confArgList[confArgNumber] = confArgList[confArgNumber] + ":"
            confArgNumber = confArgNumber + 1
        elif letter == ',':
            confArgList.append("")
            confArgNumber = confArgNumber + 1
        else: 
            try:
                confArgList[confArgNumber] = confArgList[confArgNumber] + letter
            except Exception:
                confArgList.append(letter)
for word in confArgList:
    if "\n" in word:
        confArgList[confArgList.index(word)] = word.replace("\n", "")
for word in confArgList:
    if word == "motd:":
        motd = confArgList[confArgList.index(word) + 1]
    if word == "mashPath:":
        mashPathStr = (confArgList[confArgList.index(word) + 1])
        pathStrIndex = 0
        mashPath = [""]
        for letter in mashPathStr:
            if letter == ";":
                pathStrIndex = pathStrIndex + 1
                mashPath.append("")
            else:
                try:
                    mashPath[pathStrIndex] = mashPath[pathStrIndex] + letter
                except Exception:
                    mashPath.append(letter)
    if word == "colour:":
        colourConf = confArgList[confArgList.index(word) + 1]
        colourList = [""]
        colourListIndex = 0
        for letter in colourConf:
            if letter == ";":
                colourListIndex = colourListIndex + 1
                colourList.append("")
            else:
                colourList[colourListIndex] = colourList[colourListIndex] + letter
        colourCodes = []
        for word in colourList:
            if word == 'white':
                colourCodes.append('\033[97m')
            elif word == 'blue':
                colourCodes.append('\033[34m')
            elif word == 'green':
                colourCodes.append('\033[32m')
            elif word == 'yellow':
                colourCodes.append('\033[33m')
            elif word == 'pink':
                colourCodes.append('\033[13m')
            elif word == 'red':
                colourCodes.append('\033[9m')
            elif word == 'lblue':
                colourCodes.append('\033[14m')
# Write the time to the history file
historyFile = open((expanduser("~") + "/.history.mash"), "a")
historyFile.write("\n")
historyFile.write(("Session on " + str(datetime.now())))
historyFile.write("\n")

# Welcome message. Configurable with "motd: (your motd here),"
print(motd)
os.chdir(initDirectory)
currentDirectory = initDirectory

# Main loop.
def mainLoop(startDir):
    try:
        currentDirectory = startDir
        while True:
            # Set directory and prompt for input.
            os.chdir(currentDirectory)
            command = input(colourCodes[0] + user + colourCodes[1] + "@" + colourCodes[2] + socket.gethostname() + colourCodes[3] + " " + currentDirectory + colourCodes[4] + " > ")
            if command == "" :
                mainLoop(currentDirectory)
            # Clean some things up for the argument parser.
            argNumber = 0
            argList.clear()

            # Argument parser
            for letter in command:
                if letter == " ":
                    argNumber = argNumber + 1
                else:
                    try:
                        argList[argNumber] = argList[argNumber] + letter
                    except Exception:
                        argList.append(letter)
        
            # Start work on pipes.
            for word in argList:
                if word == "&&":
                    print("This hasnt been implemented yet hahahahah")
                elif word == "&":
                    print("This hasnt been implemented yet heheheheh")
                elif word == "|":
                    print("What are you? A pipe master? We dont like those people here")
        
            # Built in commands section
            if argList[0] == "help":
                print("This is Mash, Max's Shell. Mash has a few built in commands, which you can use to run commands, view files and interact with your system.")
                print("Some commands you can run:")
                print("")
                print("cd       Change your directory.")
                print("history  See previously ran commands.")
                print("mat      View contents of a file. If you're on a Unix-like OS, use 'cat' instead.")
                print("mls      View all files in a directory. If you're on a Unix-like OS, use 'ls' instead.")
                print("version  Print current version of Mash.")
                print("exit     Exit Mash.")
                print("")
                print("You can also run commands installed by your system. See your OS's documentation for more information.")
            elif argList[0] == "exit":
                exit()
            elif argList[0] == "version":
                print(version)
            elif argList[0] == "mat":
                matFile = open(argList[1])
                print(matFile.read())
            elif argList[0] == "mls":
                try:
                    if argList[1] == "":
                        print(os.listdir(currentDirectory))
                    else:
                        argList[1] = mlsDirectory
                        if mlsDirectory[0] == "/":
                            print(os.listdir(mlsDirectory))
                        else:
                            print(os.listdir(currentDirectory + "/" + mlsDirectory))
                except Exception:
                    print(os.listdir(currentDirectory))
            elif argList[0] == "cd":
                try:
                    directoryForCD = argList[1]
                    if directoryForCD[0] == "~":
                        currentDirectory = expanduser("~") + directoryForCD.replace("~", "")
                    if directoryForCD[0] == "/":
                        currentDirectory = directoryForCD
                    else:
                        currentDirectory = (currentDirectory + "/" + directoryForCD)            
                except Exception:
                    print("Either a directory was not provided or an error occured.")
            elif argList[0] == "history":
                historyReadFile = open((expanduser("~") + "/.history.mash"))
                print(historyReadFile.read())
            elif argList[0] == "mtime":
                print(datetime.now())
            elif argList[0] == "printconf":
                print(configFile)
            # If a built in command isn't what you wanted, run a new subprocess.
            else:
                for word in mashPath:
                    if os.path.isfile(word + "/" + argList[0]):
                        argList[0] = (word + "/" + argList[0])
                try:
                    subprocess.run(argList)
                except Exception:
                    print("Command", command, "either doesn't exist, isn't in the path or isn't in this directory.")
        
            # Write to the history file
            historyFile = open((expanduser("~") + "/.history.mash"), "a")
            historyFile.write(command)
            historyFile.write("\n")
            historyFile.close()

    # Handle errors in the main loop
    #except Exception:
        #print("Looks like there was an error. Exiting...")
# Handle ^C
    except KeyboardInterrupt:
        print("\n")
        mainLoop(currentDirectory)
mainLoop(initDirectory)
